import es
import hashlib
import time
import os
from configobj import ConfigObj
import random


config = ConfigObj(open(es.getString("eventscripts_gamedir") + "/cfg/chatadmin.ini", "r"))

info = es.AddonInfo()
info.name = "Chat Admin"
info.version = "2.0.0"
info.author = "Brainsucker"

def load():
	global logfile
	if hashlib.md5(info.author).hexdigest() == "e23f4403f295a005453317e0808f8f40":
		es.ServerVar(info.name, info.version).makepublic()
		if str(config["fastkickcmd"]) != str(config["fastbancmd"]):
			es.regsaycmd(str(config["fastkickcmd"]), "chatadmin/fastkick")
			es.regsaycmd(str(config["fastbancmd"]), "chatadmin/fastban")

		else:
			es.unload("chatadmin")
			return
		if os.path.isfile(es.getAddonPath("chatadmin") + "/adminlog.txt"):
			logfile = open(es.getAddonPath("chatadmin") + "/adminlog.txt", "a")

		if not os.path.isfile(es.getAddonPath("chatadmin") + "/adminlog.txt"):
			logfile = open(es.getAddonPath("chatadmin") + "/adminlog.txt", "w")

		es.msg("#multi", "[#green%s#default] %s has been loaded..." % (time.strftime("%X"), info.name))


def fastkick():
	if es.getplayersteamid(es.getcmduserid()) in config["admins"]:
		if es.getargc() >= 2:
			if checkuserid(es.getargv(1)):
				plyuserid = checkuserid(es.getargv(1))

			else:
				giveKickExample(es.getcmduserid())
				return
			if es.getargc() > 2:
				kickreason = es.getargs().replace(es.getargv(0) + " ", "").replace(es.getargv(1) + " ", "")

			else:
				kickreason = 0

			plyname = es.getplayername(plyuserid)
			if kickreason:
				log(time.strftime("%X"), time.strftime("%d.%m.%Y"), es.getplayername(es.getcmduserid()), es.getplayersteamid(es.getcmduserid()), plyname, es.getplayersteamid(plyuserid), "kick", kickreason, None)
				es.server.cmd("kickid %s Kicked by Admin: %s" % (plyuserid, kickreason))

			else:
				log(time.strftime("%X"), time.strftime("%d.%m.%Y"), es.getplayername(es.getcmduserid()), es.getplayersteamid(es.getcmduserid()), plyname, es.getplayersteamid(plyuserid), "kick", None, None)
				es.server.cmd("kickid %s Kicked by Admin" % plyuserid)

			if int(config["show_message"]):
				if int(config["show_admin_name"]):
					es.msg("#multi", "[ADMIN #green%s#default] Kicked Player #green%s" % (es.getplayername(es.getcmduserid()), plyname))

				if not int(config["show_admin_name"]):
					es.msg("#multi", "[ADMIN] Kicked Player #green%s" % plyname)


def fastban():
	if es.getplayersteamid(es.getcmduserid()) in config["admins"]:
		if es.getargc() >= 3:
			if es.getargv(1).isdigit():
				bantime = int(es.getargv(1))

			else:
				giveBanExample(es.getcmduserid())
				return

			if checkuserid(es.getargv(2)):
				plyuserid = checkuserid(es.getargv(2))

			else:
				giveBanExample(es.getcmduserid())
				return

			if es.getargc() > 3:
				banreason = es.getargs().replace(es.getargv(0) + " ", "").replace(es.getargv(1) + " ", "").replace(es.getargv(2) + " ", "")

			else:
				banreason = 0

			plyname = es.getplayername(plyuserid)
			es.server.cmd("banid %s %s" % (bantime, plyuserid))
			if banreason:
				log(time.strftime("%X"), time.strftime("%d.%m.%Y"), es.getplayername(es.getcmduserid()), es.getplayersteamid(es.getcmduserid()), plyname, es.getplayersteamid(plyuserid), "ban", banreason, bantime)
				es.server.cmd("kickid %s Banned by Admin: %s" % (plyuserid, banreason))


			else:
				log(time.strftime("%X"), time.strftime("%d.%m.%Y"), es.getplayername(es.getcmduserid()), es.getplayersteamid(es.getcmduserid()), plyname, es.getplayersteamid(plyuserid), "ban", None, bantime)
				es.server.cmd("kickid %s Banned by Admin" % plyuserid)

			if int(config["show_message"]):
				if int(config["show_admin_name"]):
					es.msg("#multi", "[ADMIN #green%s#default] Banned Player #green%s" % (es.getplayername(es.getcmduserid()), plyname))

				if not int(config["show_admin_name"]):
					es.msg("#multi", "[ADMIN] Banned Player #green%s" % plyname)


			if bantime == 0:
				es.server.cmd("writeid")
def unload():
	es.unregsaycmd(str(config["fastkickcmd"]))
	es.unregsaycmd(str(config["fastbancmd"]))
	logfile.close()

	es.msg("#multi", "[#green%s#default] %s has been unloaded..." % (time.strftime("%X"), info.name))


def exists(a, b):
	if a == "playername":
		for player in es.getUseridList():
			if b == es.getplayername(player):
				return True

	if a == "userid":
		if b in es.getUseridList():
			return True

	if a == "steamid":
		for player in es.getUseridList():
			if b == es.getplayersteamid(player):
				return True

	return False 

def checkuserid(argument):
	if argument.isdigit():
		if exists("userid", int(argument)):
			return argument

	elif exists("steamid", argument) or exists("playername", argument):
		return es.getuserid(argument)

	return False

def log(time, date, adminname, adminsteamid, username, usersteamid, punishtype, reason=None, bantime=None):
	if punishtype == "kick":
		logfile.write("\n\n-----\nKicked:")

	elif punishtype == "ban":
		logfile.write("\n\n-----\nBanned:")

	else:
		raise "Only punishtype 'kick' or 'ban' is allowed"
		return

	logfile.write("\nDate: %s\nTime: %s\n\nAdmindetails:\nName: %s\nSTEAMID: %s\n\nUserdetails:\nName: %s\nSTEAMID: %s" % (date, time, adminname, adminsteamid, username, usersteamid))

	if bantime != None:
		if bantime == 0:
			logfile.write("\nBantime: PERMANENT")

		else:
			logfile.write("\nBantime: %i" % bantime)

	if reason == None:
		logfile.write("\n-----")

	else:
		logfile.write("\n\nReason: %s\n-----" % reason)


def giveKickExample(userid):
	randuserid = random.choice(es.getUseridList())
	es.tell(userid, "#multi", "Example Kick by Userid: #green%s %s#default." % (str(config["fastkickcmd"]), randuserid))
	es.tell(userid, "#multi", "Example Kick by Username: #green%s %s#default." % (str(config["fastkickcmd"]), es.getplayername(randuserid)))
	es.tell(userid, "#multi", "Example Kick by STEAMID: #green%s %s#default." % (str(config["fastkickcmd"]), es.getplayersteamid(randuserid)))
	es.tell(userid, "#multi", "You also can add a Reason to the end of the Command")


def giveBanExample(userid):
	randuserid = random.choice(es.getUseridList())
	randbantime = random.randint(0, 200)
	es.tell(userid, "#multi", "Example Ban by Userid: #green%s %i %s#default." % (str(config["fastbancmd"]), randbantime, randuserid))
	es.tell(userid, "#multi", "Example Ban by Username: #green%s %i %s#default." % (str(config["fastbancmd"]), randbantime, es.getplayername(randuserid)))
	es.tell(userid, "#multi", "Example Ban by STEAMID: #green%s %i %s#default." % (str(config["fastbancmd"]), randbantime, es.getplayersteamid(randuserid)))
	es.tell(userid, "#multi", "This Commads would ban the User %s for %i Minutes" % (es.getplayername(randuserid), randbantime))
	es.tell(userid, "#multi", "You also can add a Reason to the end of the Command")